# -*- coding: utf-8 -*-
"""ProductCombosSoldMost.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/12xbeoCNbNYE6wX1hPX9qK3Gc9pDGUGrx
"""



"""**Most sold products**"""
from datetime import date

today = date.today()
print("Today's date:", today)

from sqlalchemy import create_engine
import pandas as pd
engine = create_engine("mysql+pymysql://tuadmin:Turant123@turantdb-instance.cdvlyair641e.ap-south-1.rds.amazonaws.com""/turant")
connn = engine.connect()


# products= pd.read_sql("""SELECT item_id FROM (select item_id,count(item_id) itemcount from order_items
# where created_on > curdate() - interval 365 day 
# group by item_id ) AS A
# order by itemcount desc;""",con=connn)


products= pd.read_sql("""SELECT * FROM (SELECT * FROM (select item_id,count(item_id) itemcount from order_items
where created_on > curdate() - interval 365 day 
group by item_id) AS A
where A.item_id in (SELECT products.id FROM products left join stores
on stores.id=products.store_id 
where stores.status=1)) AS B
where B.item_id in (select id from products 
where status=1);""",con=connn)

"""**otherprodsearch**"""

combos= pd.read_sql("""SELECT item_id,orders.order_group_no FROM order_items
left join orders on orders.id=order_items.order_id
left join order_groups on order_groups.id=orders.order_group_no;""",con=connn)

latestpurchase= pd.read_sql("""SELECT item_id,max(created_on) as latestdate FROM order_items
group by item_id;""",con=connn)
latestpurchase['dayssince']=(pd.to_datetime(today) - pd.to_datetime(latestpurchase['latestdate'])).dt.days
latestpurchase.loc[latestpurchase['dayssince']<0,'dayssince']=0

connn.close()

final=pd.DataFrame()
for i in products['item_id']:
  temp = combos[combos['item_id']==i]
  temp2= combos[combos['order_group_no'].isin(list(temp['order_group_no']))]['item_id'].value_counts().reset_index()
  temp2['itemorigin']=i
  temp2.columns=['combo', 'count', 'itemorigin']
  temp2['corr']=temp2['count']/temp2['count'].sum()*100
  temp2=temp2[temp2['itemorigin']!=temp2['combo']]
  final=final.append(temp2[['itemorigin','combo','count','corr']][1:].head(5))

# final.to_csv('finale.csv')

# from sqlalchemy import create_engine
# import pandas as pd
# engine = create_engine("mysql+pymysql://tuadmin:Turant123@turantdb-instance.cdvlyair641e.ap-south-1.rds.amazonaws.com""/turant")
# connn = engine.connect()


# items= pd.read_sql("""SELECT id,name FROM products;""",con=connn)

# final=final.merge(items[['id','name']],left_on='itemorigin',right_on='id').merge(items[['id','name']],left_on='combo',right_on='id')


final=final.merge(latestpurchase,left_on='combo',right_on='item_id',how='left')
final=final[['itemorigin', 'combo', 'count', 'corr', 'latestdate',
       'dayssince']]
quantiles = final.quantile(q=[0.20,0.4,0.6,0.8])
quantiles = quantiles.to_dict()

def RScore(x,p,d):
    if x <= d[p][0.20]:
        return 5
    elif x <= d[p][0.40]:
        return 4
    elif x <= d[p][0.60]: 
        return 3
    elif x <= d[p][0.80]: 
        return 2
    else:
        return 1

    
final['r_quartile']=final['dayssince']

for i in range(len(final['dayssince'])):
    if (final['dayssince'][i]<=quantiles['dayssince'][0.2]):
        final['r_quartile'][i]=5
    elif (final['dayssince'][i]<=quantiles['dayssince'][0.4]):
        final['r_quartile'][i]=4
    elif (final['dayssince'][i]<=quantiles['dayssince'][0.6]):
        final['r_quartile'][i]=3
    elif (final['dayssince'][i]<=quantiles['dayssince'][0.8]):
        final['r_quartile'][i]=2
    else:
        final['r_quartile'][i]=1
final['corr']=final['r_quartile']*final['corr']/5

from datetime import date

today = date.today()
print("Today's date:", today)
print(final.columns)
final=final[['itemorigin', 'combo', 'count', 'corr']]
final.columns=['productselected_id','suggestedproduct_id','count','corr']
import datetime
final['date']=datetime.datetime.now()

engine = create_engine("mysql+pymysql://tuadmin:Turant123@turantdb-instance.cdvlyair641e.ap-south-1.rds.amazonaws.com""/turant")
con = engine.connect()
final.to_sql('ProductSuggestion',if_exists='replace',index=False,con=con)
con.close()